<?php
/****************************************************************************
 * DRBImageGallery
 * http://www.dbscripts.net/imagegallery/
 * 
 * Copyright  2007 Don Barnes 
 ****************************************************************************/
 
function show_attributes() {
	global $donsimg_error;

	// Open database connection	
	if(db_connect() === FALSE) {
		die("Error connecting to database: " . htmlspecialchars(db_error()));
	}

	include_from_template('header.php');
	
?>

<h2>Attribute Management</h2>

<?php
if(isset($donsimg_error)) {
	echo "<p class=\"errorMessage\">" . htmlspecialchars($donsimg_error) . "</p>";
}
global $MAX_ATTRIBUTE_NAME_LENGTH;
?>

<form method="post" action=".">
<fieldset>
<legend>Add Attribute</legend>
<p>
<label for="name">Name:</label>
<input type="hidden" name="action" value="addattribute" />
<input type="text" name="name" id="name" maxlength="<?php echo(htmlspecialchars($MAX_ATTRIBUTE_NAME_LENGTH)); ?>" />
</p>
<input type="submit" value="Save" class="submit" />
</fieldset>  
</form>

<h3>Attributes</h3>

<?php

	attribute_table();
	
	show_back_button();

	include_from_template('footer.php');

}

function show_attribute($attribute) {
	global $donsimg_error;
	
	// Open database connection	
	if(db_connect() === FALSE) {
		die("Error connecting to database: " . htmlspecialchars(db_error()));
	}

	include_from_template('header.php');

?>

<h2>Edit Attribute</h2>

<?php
if(isset($donsimg_error)) {
	echo "<p class=\"errorMessage\">" . htmlspecialchars($donsimg_error) . "</p>";
}
global $MAX_ATTRIBUTE_NAME_LENGTH;
global $MAX_ATTRIBUTE_VALUE_LENGTH;
?>

<form method="post" action=".">
<fieldset>
<legend>Edit Attribute</legend>
<p>
<input type="hidden" name="action" value="saveattribute" />
<input type="hidden" name="attributeId" id="attributeId" value="<?php echo(htmlspecialchars($attribute['attributeId'])); ?>" />
<label for="name">Name:</label>
<input type="text" name="name" id="name" value="<?php echo(htmlspecialchars($attribute['name'])); ?>" maxlength="<?php echo(htmlspecialchars($MAX_ATTRIBUTE_NAME_LENGTH)); ?>" />
</p>
<input type="submit" value="Save" class="submit" />
</fieldset>  
</form>

<h2>Attribute Values</h2>

<form method="post" action=".">
<fieldset>
<legend>Add Value</legend>
<p>
<label for="value">Value:</label>
<input type="hidden" name="action" value="addvalue" />
<input type="hidden" name="attributeId" value="<?php echo(htmlspecialchars($attribute['attributeId'])); ?>" />
<input type="text" name="value" id="value" maxlength="<?php echo(htmlspecialchars($MAX_ATTRIBUTE_VALUE_LENGTH)); ?>" />
</p>
<input type="submit" value="Save" class="submit" />
</fieldset>  
</form>

<?php

	value_table_by_attributeId($attribute['attributeId']);
	
?>
<form method="post" action=".">
<p>
<input type="hidden" name="action" value="showattributes" />
<input type="submit" value="Back to Attribute Management" class="submit" />
</p>
</form>
<?php

	show_back_button();

	include_from_template('footer.php');

}

?>