<?php
/****************************************************************************
 * DRBImageGallery
 * http://www.dbscripts.net/imagegallery/
 * 
 * Copyright  2007 Don Barnes 
 ****************************************************************************/
 
function scan_dir_for_deletes($basedirname, $basethumbdirname) {
	global $CREATE_THUMBS;
	global $donsimg_error;

	$dirname = rtrim($basedirname, "/");
	$thumbdirname = rtrim($basethumbdirname, "/");

	// Loop over image records for missing files
	$res = find_images(NULL, 'filename');
	while( ($assoc = db_fetch($res)) !== FALSE ) {
		
		$filename = $assoc['filename'];
		$filepath = $dirname . '/' . $filename;
		if(!file_exists($filepath)) {
			echo("'" . htmlspecialchars($filename) . "' was not found in the images directory; deleting from database.<br />");
			delete_image_by_filename($filename);
			
			if($CREATE_THUMBS === TRUE) {
				if(delete_thumbnail($thumbdirname, $filename) === FALSE) {
					echo("Error deleting thumbnail: " . htmlspecialchars($donsimg_error) ."<br />");
				}
			}
			
		} else {
			//echo("'" . htmlspecialchars($filename) . "' was found in the images directory.<br />");
		}
		
		// Flush status to user
		flush();
	}
	db_free_result($res);
	
}

function scan_dir_for_adds($basedirname, $basethumbdirname, $subdirpath = "") {
	global $CREATE_THUMBS;
	global $donsimg_error;
	
	$dirname = rtrim($basedirname, "/") . "/" . $subdirpath;
	$thumbdirname = rtrim($basethumbdirname, "/") . "/" . $subdirpath;

	// Open images directory	
	$dir = opendir($dirname);
	if($dir === FALSE) {
		die("Cannot open folder: " . $dirname);
	}
	
	// Loop over files in directory
	while( ($filename = readdir($dir)) !== FALSE ) {
		
		if($filename != '..' && $filename != '.') {
			
			if(is_dir($dirname . $filename)) {
				
				// Traverse subdirectory
				scan_dir_for_adds($basedirname, $basethumbdirname, $subdirpath . $filename . "/");
				
			} else if(is_image_file($filename)) {
				
				$fullfilename = $subdirpath . $filename;
				
				// Check if image is already in image folder
				if(find_image_by_filename($fullfilename) === FALSE) {
					
					// File was not found, add to table
					echo("'" . htmlspecialchars($fullfilename) . "' was not found in the database; adding.<br />");
					if(add_new_image($fullfilename, $basedirname, $basethumbdirname) === FALSE) {
						global $donsimg_error;
						echo("Error adding image: " . htmlspecialchars($donsimg_error) . "<br />");
					}
	
					
				} else {
					
					//echo("'" . htmlspecialchars($fullfilename) . "' is already in the database.<br />");
					
					if($CREATE_THUMBS === TRUE) {
						
						// Check for missing thumbnail images
						$thumbfilepath = $thumbdirname . '/' . $filename;
						if(!file_exists($thumbfilepath)) {
							echo("Creating missing thumbnail for " . htmlspecialchars($filename) . "<br />\n");
							if(create_thumbnail($dirname, $thumbdirname, $filename) === FALSE) {
								echo("Error creating thumbnail for " . htmlspecialchars($filename) . ": " . htmlspecialchars($donsimg_error) . "<br />");
							}
						}
						
					}
	
				}
				
			}
			
		}
		
		// Flush status to user
		flush();
		
	}
	
	// Close directory
	closedir($dir);

}
	
function do_scan() {
	global $IMAGE_FOLDER;
	global $THUMB_FOLDER;
	global $donsimg_base_path;
	
	include_from_template('header.php');

	echo('<h2>Scan Images Folder</h2>');

	// Open database connection	
	db_connect();
	
	$image_path = $donsimg_base_path . $IMAGE_FOLDER;
	$thumb_path = $donsimg_base_path . $THUMB_FOLDER;

	echo("<p>Scanning '" . htmlspecialchars($IMAGE_FOLDER) . "' folder for deleted images...</p>");
	scan_dir_for_deletes($image_path, $thumb_path, "");

	// Scan directory
	echo("<p>Scanning '" . htmlspecialchars($IMAGE_FOLDER) . "' folder for new images...</p>");
	scan_dir_for_adds($image_path, $thumb_path, "");

	echo('<h2>Scanning complete.</h2>');
	
	show_back_button();
	
	include_from_template('footer.php');

}
?>