<?php
/****************************************************************************
 * DRBImageGallery
 * http://www.dbscripts.net/imagegallery/
 * 
 * Copyright  2007 Don Barnes 
 ****************************************************************************/

$donsimg_error = NULL;

function include_from_template($filename) {
	global $SITE_TITLE;
	include path_to_file_from_template($filename);
}

function path_to_file_from_template($filename) {
	global $TEMPLATE_NAME;
	global $donsimg_base_path;
	return $donsimg_base_path . 'template/' . $TEMPLATE_NAME . '/' . $filename;
}

function relative_location($relativeURI) {
	$baseURL = base_URL(); 
	header("Location: $baseURL/$relativeURI");
}

function base_URL() {
	$domain = $_SERVER['HTTP_HOST'];
	$baseURI = rtrim(dirname($_SERVER['PHP_SELF']), '\\/');
	
	// Work around for sites using sub directory hosting
	if(substr($baseURI, 0, strlen("/" . $domain . "/")) === "/" . $domain . "/") {
		$baseURI = substr($baseURI, strlen("/" . $domain . "/"));
	}
	
	return "http://$domain$baseURI";
}

function get_file_extension($filepath) {
	$lastdot = strrpos($filepath, ".");
	if($lastdot === FALSE) {
		return FALSE;
	}
	$filetype = strtolower(substr($filepath, $lastdot + 1));
	return $filetype;
}

function replace_file_extension($filepath, $newext) {
	$lastdot = strrpos($filepath, ".");
	if($lastdot === FALSE) {
		return FALSE;
	}
	return substr($filepath, 0, $lastdot + 1) . $newext;
}

function validate_length($assoc, $key, $maxlen) {
	global $donsimg_error;
	
	if(isset($assoc[$key]) && strlen($assoc[$key]) > $maxlen) {
		$donsimg_error = "The " . htmlspecialchars($key) . " field cannot accept values over " . htmlspecialchars($maxlen) . " characters in length.";
		return FALSE;
	}
	return TRUE;
}

function validate_notempty($assoc, $key, $name = NULL) {
	global $donsimg_error;
	
	if(isset($assoc[$key]) && empty($assoc[$key])) {
		if(!isset($name)) $name = $key;
		$donsimg_error = "The " . htmlspecialchars($name) . " field is required.";
		return FALSE;
	}
	return TRUE;
}

function confirm_install() {
	global $donsimg_base_path;
	
	// Confirm that install script has been deleted
	if(file_exists($donsimg_base_path . 'install.php')) {
		die("You must complete the <a href=\"{$donsimg_base_path}install.php\">install process</a> before using the application.  If you have already completed the install process, please delete install.php at this time.");
	}
	
	// Confirm that default password was changed
	global $ADMIN_PASSWORD;
	if($ADMIN_PASSWORD === "password") {
		die("You must change the default admin password in config.php before using the application.");
	}
}

function the_site_title() {
	global $SITE_TITLE;
	echo htmlspecialchars($SITE_TITLE);
}

/* DO NOT REMOVE OR HIDE THE CREDIT BELOW, PER LICENSE! */
function the_credits() {
	echo("<div class=\"credit\">Powered by DRBImageGallery, a free PHP <a href=\"http://www.dbscripts.net/imagegallery/\">searchable image gallery script</a></div>\n");
}
/* END CREDIT */ 
	
?>